// SuperGrid1View.cpp : implementation of the CSuperGrid1View class
//

#include "stdafx.h"
#include "GfxList.h"

#include "SuperGrid1Doc.h"
#include "SuperGrid1View.h"

#include "GfxCustomizeColumnDlg.h"
#include "GfxFormatColumnDlg.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSuperGrid1View

IMPLEMENT_DYNCREATE(CSuperGrid1View, CFormView)

BEGIN_MESSAGE_MAP(CSuperGrid1View, CFormView)
	//{{AFX_MSG_MAP(CSuperGrid1View)
	ON_WM_SIZE()
	ON_NOTIFY(LVN_GETDISPINFO, IDC_LIST1, OnGetdispinfoList1)
	ON_COMMAND(ID_CUSTOMHEADER, OnCustomheader)
	ON_COMMAND(ID_FORMATHEADER, OnFormatheader)
	ON_COMMAND(ID_TESTCAT, OnTestcat)
	ON_UPDATE_COMMAND_UI(ID_TESTCAT, OnUpdateTestcat)
	ON_NOTIFY(NM_DBLCLK, IDC_LIST1, OnDblclkList1)
	ON_COMMAND(ID_ADDANITEM, OnAddanitem)
	ON_WM_DESTROY()
	ON_COMMAND(ID_BLENDBMP, OnBlendbmp)
	ON_UPDATE_COMMAND_UI(ID_BLENDBMP, OnUpdateBlendbmp)
	ON_COMMAND(ID_TRYBITMAP1, OnTrybitmap1)
	ON_UPDATE_COMMAND_UI(ID_TRYBITMAP1, OnUpdateTrybitmap1)
	ON_COMMAND(ID_TRYBITMAP2, OnTrybitmap2)
	ON_UPDATE_COMMAND_UI(ID_TRYBITMAP2, OnUpdateTrybitmap2)
	ON_COMMAND(ID_DRAGGABLECOL, OnDraggablecol)
	ON_UPDATE_COMMAND_UI(ID_DRAGGABLECOL, OnUpdateDraggablecol)
	ON_COMMAND(ID_GRIDH, OnGridh)
	ON_UPDATE_COMMAND_UI(ID_GRIDH, OnUpdateGridh)
	ON_COMMAND(ID_GRIDV, OnGridv)
	ON_UPDATE_COMMAND_UI(ID_GRIDV, OnUpdateGridv)
	ON_COMMAND(ID_EDIT_COPY, OnEditCopy)
	ON_COMMAND(ID_TESTDAO, OnTestdao)
	ON_UPDATE_COMMAND_UI(ID_TESTDAO, OnUpdateTestdao)
	ON_COMMAND(ID_RECORD_FIRST, OnRecordFirst)
	ON_UPDATE_COMMAND_UI(ID_RECORD_FIRST, OnUpdateRecordFirst)
	ON_COMMAND(ID_RECORD_LAST, OnRecordLast)
	ON_UPDATE_COMMAND_UI(ID_RECORD_LAST, OnUpdateRecordLast)
	ON_COMMAND(ID_RECORD_NEXT, OnRecordNext)
	ON_UPDATE_COMMAND_UI(ID_RECORD_NEXT, OnUpdateRecordNext)
	ON_COMMAND(ID_RECORD_PREV, OnRecordPrev)
	ON_UPDATE_COMMAND_UI(ID_RECORD_PREV, OnUpdateRecordPrev)
	//}}AFX_MSG_MAP
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CFormView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CFormView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CFormView::OnFilePrintPreview)
END_MESSAGE_MAP()
//	ON_UPDATE_COMMAND_UI_RANGE(1, 10, OnListCmdUpdate)

/////////////////////////////////////////////////////////////////////////////
// CSuperGrid1View construction/destruction

CSuperGrid1View::CSuperGrid1View()
	: CFormView(CSuperGrid1View::IDD)
{
	//{{AFX_DATA_INIT(CSuperGrid1View)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// TODO: add construction code here

	lima.Create(IDB_ARANLIST, 16, 0, RGB(255,0,255));
	limah.Create(IDB_ARANCOL, 11, 0, RGB(255,0,255));

	ftTimes.CreatePointFont(110, "Times New Roman");

	iSelBmp = -1;
	bTestingDao = false;
}

CSuperGrid1View::~CSuperGrid1View()
{
}

void CSuperGrid1View::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSuperGrid1View)
	DDX_Control(pDX, IDC_LIST1, wndList);
	//}}AFX_DATA_MAP
}

BOOL CSuperGrid1View::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CFormView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CSuperGrid1View printing

BOOL CSuperGrid1View::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}

void CSuperGrid1View::OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo)
{
	wndList.SetPrintFlag(ptUseColor|ptUseFonts|ptListName|ptPageNumbers|ptPageDate);
	wndList.SetPrintName("here's the data name");
	wndList.SetMargins(15,10,10,10);
	wndList.OnBeginPrinting(pDC, pInfo);
}

void CSuperGrid1View::OnEndPrinting(CDC* pDC, CPrintInfo* pInfo)
{
	wndList.OnEndPrinting(pDC, pInfo);
}

void CSuperGrid1View::OnPrint(CDC* pDC, CPrintInfo* pInfo)
{
	wndList.OnPrint(pDC, pInfo);
}

/////////////////////////////////////////////////////////////////////////////
// CSuperGrid1View diagnostics

#ifdef _DEBUG
void CSuperGrid1View::AssertValid() const
{
	CFormView::AssertValid();
}

void CSuperGrid1View::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}

CSuperGrid1Doc* CSuperGrid1View::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CSuperGrid1Doc)));
	return (CSuperGrid1Doc*)m_pDocument;
}
#endif //_DEBUG


/////////////////////////////////////////////////////////////////////////////
// CSuperGrid1View message handlers

void CSuperGrid1View::OnSize(UINT nType, int cx, int cy) 
{
	CFormView::OnSize(nType, cx, cy);

	if (wndList.GetSafeHwnd()) wndList.SetWindowPos(0,2,2,cx-4,cy-4,SWP_NOZORDER);
	
}

void CSuperGrid1View::OnInitialUpdate() 
{
	CFormView::OnInitialUpdate();

	wndList.OnInit();
	wndList.ModifyFlag(0,fHighRowSelect|fVertGrid|fHorizGrid,0);
	SetWindowPos(0,0,0,0,0,SWP_FRAMECHANGED);
	
	wndList.SetItemHeight(17);

//	wndList.SetGetTextCallback((void (CWnd::*)(int , int, long, CString &)) GetTextCallback);
	wndList.SetExInfoCallback((long (CWnd::*)(LXHDREX *))GetExInfoCallback);
//	wndList.SetCategoryCallback((void (CWnd::*)(CGfxCategoryManager * , long &))CategoryCallBack);
	wndList.SetDaoCategoryCallback((void (CWnd::*)(CGfxCategoryManager *))CategoryDBaseCallBack);

//	wndList.ModifyExStyle(0, LVS_EX_TRACKSELECT|LVS_EX_ONECLICKACTIVATE);

	if (!(cDaoSet.IsOpen())) cDaoSet.Open();
	if (!(cDaoMat.IsOpen())) cDaoMat.Open();

	if (!(cDaoGeo.IsOpen())) cDaoGeo.Open();
	if (!(cDaoType.IsOpen())) cDaoType.Open();
	if (!(cDaoPelle.IsOpen())) cDaoPelle.Open();

	wndList.SetRedraw(false);
	wndList.BindDaoRecordset(&cDaoSet);
	wndList.FillRecordsetColumn();

	VERIFY(wndList.LinkRecordset("Materiale", &cDaoMat, "ObjCode", "Testo_It"));
//	VERIFY(wndList.LinkRecordset(5, &cDaoMat, 0, 1));
	VERIFY(wndList.LinkRecordset("Geometria", &cDaoGeo, "ObjCode", "Testo_It"));
	VERIFY(wndList.LinkRecordset("Tipo", &cDaoType, "ObjCode", "Testo_It"));
	VERIFY(wndList.LinkRecordset("Pellicola", &cDaoPelle, "ObjCode", "Testo_It"));

	wndList.FillDaoItems();
	wndList.SetRedraw(true);

}

void CSuperGrid1View::CategoryDBaseCallBack(CGfxCategoryManager * pCatMan)
{
	CString sql, cs;

	bool bLoop = true;
	int cd = 0, iCat;

	while (bLoop)
	{
		sql.Format("ObjCode >= %d AND ObjCode < %d", cd, cd + 100);
		cs.Format("%d - %d", cd, cd + 100);
		
		bLoop = cDaoSet.FindFirst(sql) ? true : false;
		bool bFind = bLoop;
		if (bFind)
		{
			iCat = pCatMan->AddCategory(cs, cd, cd + 100);
		}
		while (bFind)
		{
			pCatMan->AddItemToCategory(iCat, cDaoSet.GetAbsolutePosition());
			bFind = cDaoSet.FindNext(sql) ? true : false;
		}
		cd += 100;
	}
}

void CSuperGrid1View::CategoryCallBack(CGfxCategoryManager * pCatMan, long & lData)
{
	COleVariant varValue;

	try
	{
		cDaoSet.SetAbsolutePosition(lData);//Set the file to desired index
	}
	catch(CDaoException* e)
	{
		e->Delete();
		return;		
	}
	
	try
	{
		cDaoSet.GetFieldValue(2, varValue);
	}
	catch(CDaoException* e)
	{
		e->Delete();
		return;
	}

	varValue.ChangeType(VT_I4);
	const VARIANT* variant = LPCVARIANT(varValue);


	long value = lData;

	int iCat = pCatMan->FindCategory(variant->lVal);
	if (iCat < 0)
	{
		CString cs;
		long val1 = value / 20;
		val1 *= 20;
		long val2 = val1 + 20;

		cs.Format("%d", variant->lVal);
		iCat = pCatMan->AddCategory(cs, variant->lVal, variant->lVal+1);
	}
	if (iCat >= 0)
	{
		pCatMan->AddItemToCategory(iCat, value);
	}
}

void CSuperGrid1View::GetTextCallback(int iIndex, int iSubItem, long lCode, CString &cs)
{
	wndList.OnDaoGetTextCallback(iIndex, iSubItem, lCode, cs);
}

void CSuperGrid1View::OnGetdispinfoList1(NMHDR* pNMHDR, LRESULT* pResult) 
{
	wndList.OnDaoGetDispInfo(pNMHDR, pResult);
}


void CSuperGrid1View::OnCustomheader() 
{
	wndList.OnGfxCustomizehead();
}

void CSuperGrid1View::OnFormatheader() 
{
	wndList.OnGfxFormatheader();
}

void CSuperGrid1View::OnListCmdUpdate(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(true);
}

void CSuperGrid1View::OnTestcat() 
{
	CWaitCursor tom;

	if (wndList.GetCategoryManager()) wndList.EnableCategoryView(false);
	else wndList.EnableCategoryView(true);
	
}

void CSuperGrid1View::OnUpdateTestcat(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(wndList.GetCategoryManager() != NULL);
}

void CSuperGrid1View::OnDblclkList1(NMHDR* pNMHDR, LRESULT* pResult) 
{
	*pResult = 0;
	int i = wndList.GetNextItem(-1, LVNI_SELECTED);
	if (i < 0) return;
	int idx = wndList.GetItemData(i);
	CString cs;
	cs.Format("Click on %d", idx);
	AfxMessageBox(cs);	
}

long CSuperGrid1View::GetExInfoCallback(LXHDREX * pLx)
{
	ASSERT(pLx);
	return wndList.GetExInfoCallback(pLx);
}


void CSuperGrid1View::OnAddanitem() 
{
}

void CSuperGrid1View::OnDestroy() 
{
	CFormView::OnDestroy();
}

void CSuperGrid1View::OnBlendbmp() 
{
	wndList.SetBlendBitmap(!wndList.bBlendBitmap);
	wndList.Invalidate();
}

void CSuperGrid1View::OnUpdateBlendbmp(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(wndList.bBlendBitmap);
	pCmdUI->Enable(iSelBmp >= 0);

}

void CSuperGrid1View::OnTrybitmap1() 
{
	if (iSelBmp == 0)
	{
		wndList.SetBkImage(-1);
		iSelBmp = -1;
	}
	else 
	{
		wndList.SetBkImage(IDB_BITMAP1);
		iSelBmp = 0;
	}
	wndList.Invalidate();
}

void CSuperGrid1View::OnUpdateTrybitmap1(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(iSelBmp == 0);
}

void CSuperGrid1View::OnTrybitmap2() 
{
	if (iSelBmp == 1)
	{
		wndList.SetBkImage(-1);
		iSelBmp = -1;
	}
	else 
	{
		wndList.SetBkImage(IDB_BITMAP2);
		iSelBmp = 1;
	}
	wndList.Invalidate();
}

void CSuperGrid1View::OnUpdateTrybitmap2(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(iSelBmp == 1);
}

void CSuperGrid1View::OnDraggablecol() 
{
	wndList.EnableColumnDrag(!wndList.IsColumnDragEnabled());
}

void CSuperGrid1View::OnUpdateDraggablecol(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(wndList.IsColumnDragEnabled());	
}

void CSuperGrid1View::OnGridh() 
{
	if (wndList.GetFlag() & fHorizGrid) wndList.ModifyFlag(fHorizGrid, 0, 0);
	else wndList.ModifyFlag(0, fHorizGrid, 0);

	Invalidate();
	
}

void CSuperGrid1View::OnUpdateGridh(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(wndList.GetFlag() & fHorizGrid ? 1 : 0);
}

void CSuperGrid1View::OnGridv() 
{
	if (wndList.GetFlag() & fVertGrid) wndList.ModifyFlag(fVertGrid, 0, 0);
	else wndList.ModifyFlag(0, fVertGrid, 0);
	Invalidate();
}

void CSuperGrid1View::OnUpdateGridv(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(wndList.GetFlag() & fVertGrid ? 1 : 0);
	
}

void CSuperGrid1View::OnEditCopy() 
{
	wndList.DoCopyInClipboard(wndList.GetSelectedCount() > 0 ? true : false);
}

void CSuperGrid1View::OnTestdao() 
{
}

void CSuperGrid1View::OnUpdateTestdao(CCmdUI* pCmdUI) 
{
}

void CSuperGrid1View::OnRecordFirst() 
{
	wndList.OnMoveFirstRecord();
}

void CSuperGrid1View::OnUpdateRecordFirst(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(wndList.EnableMoveFirst());
}

void CSuperGrid1View::OnRecordLast() 
{
	wndList.OnMoveLastRecord();
}

void CSuperGrid1View::OnUpdateRecordLast(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(wndList.EnableMoveLast());
}

void CSuperGrid1View::OnRecordNext() 
{
	wndList.OnMoveNextRecord();
}

void CSuperGrid1View::OnUpdateRecordNext(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(wndList.EnableMoveNext());
}

void CSuperGrid1View::OnRecordPrev() 
{
	wndList.OnMovePrevRecord();
}

void CSuperGrid1View::OnUpdateRecordPrev(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(wndList.EnableMovePrev());
}
