// TestDaoSet.cpp : implementation file
//

#include "stdafx.h"
#include "GfxList.h"
#include "TestDaoSet.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CTestDaoSet

IMPLEMENT_DYNAMIC(CTestDaoSet, CDaoRecordset)

CTestDaoSet::CTestDaoSet(CDaoDatabase* pdb)
	: CDaoRecordset(pdb)
{
	//{{AFX_FIELD_INIT(CTestDaoSet)
	m_ObjCode = 0;
	m_ImpCode = 0;
	m_Geometria = 0;
	m_Dimensioni = _T("");
	m_Pellicola = 0;
	m_Materiale = 0;
	m_Tipo = 0;
	m_Attacco = 0;
	m_Ordinanza = _T("");
	m_Fabbricazione = _T("");
	m_Figura = _T("");
	m_Stato = 0;
	m_CDS = 0;
	m_Installazione = _T("");
	m_Fabbricante = 0;
	m_Autorizzazione = _T("");
	m_Fornitore = 0;
	m_Rilevamento = _T("");
	m_Note = _T("");
	m_NoteDt = _T("");
	m_NoteRev = _T("");
	m_ABool = FALSE;
	m_Posa = _T("");
	m_Ente = 0;
	m_nFields = 24;
	//}}AFX_FIELD_INIT
	m_nDefaultType = dbOpenDynaset;
}


CString CTestDaoSet::GetDefaultDBName()
{
	return _T("Cortina1.mdb");
}

CString CTestDaoSet::GetDefaultSQL()
{
	return _T("[Segnali]");
}

void CTestDaoSet::DoFieldExchange(CDaoFieldExchange* pFX)
{
	//{{AFX_FIELD_MAP(CTestDaoSet)
	pFX->SetFieldType(CDaoFieldExchange::outputColumn);
	DFX_Long(pFX, _T("[ObjCode]"), m_ObjCode);
	DFX_Long(pFX, _T("[ImpCode]"), m_ImpCode);
	DFX_Long(pFX, _T("[Geometria]"), m_Geometria);
	DFX_Text(pFX, _T("[Dimensioni]"), m_Dimensioni);
	DFX_Long(pFX, _T("[Pellicola]"), m_Pellicola);
	DFX_Long(pFX, _T("[Materiale]"), m_Materiale);
	DFX_Long(pFX, _T("[Tipo]"), m_Tipo);
	DFX_Long(pFX, _T("[Attacco]"), m_Attacco);
	DFX_Text(pFX, _T("[Ordinanza]"), m_Ordinanza);
	DFX_Text(pFX, _T("[Fabbricazione]"), m_Fabbricazione);
	DFX_Text(pFX, _T("[Figura]"), m_Figura);
	DFX_Long(pFX, _T("[Stato]"), m_Stato);
	DFX_Short(pFX, _T("[CDS]"), m_CDS);
	DFX_Text(pFX, _T("[Installazione]"), m_Installazione);
	DFX_Long(pFX, _T("[Fabbricante]"), m_Fabbricante);
	DFX_Text(pFX, _T("[Autorizzazione]"), m_Autorizzazione);
	DFX_Long(pFX, _T("[Fornitore]"), m_Fornitore);
	DFX_Text(pFX, _T("[Rilevamento]"), m_Rilevamento);
	DFX_Text(pFX, _T("[Note]"), m_Note);
	DFX_Text(pFX, _T("[NoteDt]"), m_NoteDt);
	DFX_Text(pFX, _T("[NoteRev]"), m_NoteRev);
	DFX_Bool(pFX, _T("[ABool]"), m_ABool);
	DFX_Text(pFX, _T("[Posa]"), m_Posa);
	DFX_Long(pFX, _T("[Ente]"), m_Ente);
	//}}AFX_FIELD_MAP
}

/////////////////////////////////////////////////////////////////////////////
// CTestDaoSet diagnostics

#ifdef _DEBUG
void CTestDaoSet::AssertValid() const
{
	CDaoRecordset::AssertValid();
}

void CTestDaoSet::Dump(CDumpContext& dc) const
{
	CDaoRecordset::Dump(dc);
}
#endif //_DEBUG
